import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Fighter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Fighter extends Actor
{
    ActionKeyboard myBoard = null;
    Fighter myOpponent = null;
    Counter myCounter = null;
    
    boolean leftFacing = false;
    boolean knocking = false;
    boolean dist = false;
    boolean getClocked = false;

    SpriteSheet rightSheet = null;
    SpriteSheet leftSheet = null;
    GreenfootImage StandLookRight = null;
    GreenfootImage StandLookLeft = null;
    Animator myAnimator = new Animator();
    //Animator opponentAnimator = new Animator();
    int gravity = 0;
    int tick = 40;
    int tickX = 0;
    int knockback = 0;
    int distance = 0;
    public static int FLOOR_Y = 330;
    

    String myName = "";
    
    public Fighter()
    {
        
    }
    
    public void setCounter(Counter count)
    {
         myCounter = count;
         myAnimator.setCount(count);
    }
    
    public void setOpponentAnimator(Animator opponent)
    {
        myAnimator.setOpponent(opponent);
    }
    
    public void setOpponent(Fighter opponent)
    {
        myOpponent = opponent;
        setDirection();
        myOpponent.setOpponentAnimator(myAnimator);
        myAnimator.setFighterOpponent(opponent);
    }
    
    public void setSpritePaths(String leftPath, String rightPath)
    {
         rightSheet = new SpriteSheet(rightPath, 4, 4);
         leftSheet = new SpriteSheet(leftPath, 4, 4);
         StandLookRight = rightSheet.getSprite(0, 0);
         StandLookLeft = leftSheet.getSprite(0, 0);
    }
    
    public void setName(String name)
    {
        myName = name;
    }
    
    public String getName()
    {
        return myName;
    }
    
    public void setLeftKeyboard(boolean left)
    {
        myBoard = new ActionKeyboard(left); 
    }
    
    public void act()
    {
        checkKick();
        checkKnockback();
        withinXRange();
        checkPunch();
        checkBlock();
        checkWalk();
        checkForJump();
        this.setImage(myAnimator.getDisplayImage());
        setFloor();
        checkDuck();
    }
    
    public void checkKick()
    { 
        if ((Greenfoot.isKeyDown(myBoard.duck())) && (Greenfoot.isKeyDown(myBoard.moveLeft())) && leftFacing){
            myAnimator.setKicking(true);
            myAnimator.setWalking(false);
        }
        if ((Greenfoot.isKeyDown(myBoard.duck())) && (Greenfoot.isKeyDown(myBoard.moveRight())) && !leftFacing){
            myAnimator.setKicking(true);
            myAnimator.setWalking(false);
        }
    }
    
    public void checkKnockback()
    {
        if(leftFacing){
            setLocation(getX() + knockback, getY());
        }else{
            setLocation(getX() - knockback, getY());
        }
        
        if (knocking) {
             if(tickX == 0){
                 knockback = distance;                 
             }
             knockback -= 2;
             tickX += 2;
             if(!dist){
                 myAnimator.setOuch(true);
             }
             if(tickX > distance){
                 setKnockback(false, distance);
                 myAnimator.setOuch(false);
                 knockback = 0;
                 tickX = 0;
             }
        }
    }
    
    public void setKnockback(boolean knock, int dis)
    {
        if(knock){
            knocking = true;
        }else{
            knocking = false;
        }
        if(dis < 10){
            dist = true;
        }else{
            dist = false;
        }
        distance = dis;
    }
    
    public void withinXRange()
    {
        if((this.getX() < myOpponent.getX() + 67) && (this.getX() > myOpponent.getX() - 67)){
            myAnimator.setRange(true);
        }else{
            myAnimator.setRange(false);
        }
    }
    
    private void checkForJump()
    {
        gravity--;
        setLocation(getX(), getY() - gravity);
        tick++;
        if(tick == 40){
            myAnimator.setJump(false);
            getClocked = false;
        }
        if ((Greenfoot.isKeyDown(myBoard.jump()))&& tick > 40) {
             gravity = 17; //  jump height
             tick = 0;
             myAnimator.setJump(true);
        }
        if((getClocked)&& tick > 40){
            gravity = 14;
            tick = 0;
            myAnimator.setOuch(true);
        }
    }
    
    public void setFloor()
    {
        if(this.getY() >= FLOOR_Y){
            setLocation(getX(), FLOOR_Y);
        }
    }
    
    public void checkBlock()
    {
        if ((Greenfoot.isKeyDown(myBoard.moveLeft())) && (Greenfoot.isKeyDown(myBoard.moveRight())) ){
            myAnimator.setBlock(true);
            myAnimator.setWalking(false);
        }else{
            myAnimator.setBlock(false);
        }
    }
    
    public void checkWalk()
    {
        
        if ((Greenfoot.isKeyDown(myBoard.moveLeft())) && !(Greenfoot.isKeyDown(myBoard.moveRight())) && !Greenfoot.isKeyDown(myBoard.duck())) { 
            if((this.getX() > (myOpponent.getX() + 40)) && leftFacing){
                setLocation((getX() - 3), getY());
            }
            if(!leftFacing){
                setLocation((getX() - 3), getY());
            }

            myAnimator.setWalking(true);
            if(this.getY() < (myOpponent.getY())){
                setLocation((getX() - 3), getY());
                myAnimator.setWalking(false);
                myAnimator.setJump(true);
            }
            setDirection();
        }else if (Greenfoot.isKeyDown(myBoard.moveRight()) && !(Greenfoot.isKeyDown(myBoard.moveLeft())) && !Greenfoot.isKeyDown(myBoard.duck())) {
            if((this.getX() < (myOpponent.getX() - 40)) && !leftFacing){
                setLocation((getX() + 3), getY());
            }
            if(leftFacing){
                setLocation((getX() + 3), getY());
            }
            
            myAnimator.setWalking(true);
            if(this.getY() < (myOpponent.getY())){
                setLocation((getX() + 3), getY());
                myAnimator.setWalking(false);
                myAnimator.setJump(true);
            }
            setDirection();
        }else{ 
            myAnimator.setWalking(false);
        }
        
    }
    
    public void checkPunch()
    {
        if ((Greenfoot.isKeyDown(myBoard.punch())) && (Greenfoot.isKeyDown(myBoard.duck()))){
            myAnimator.setUppercut(true);
            myAnimator.setPunch(false);
        }
        if (Greenfoot.isKeyDown(myBoard.punch())){
            myAnimator.setPunch(true);
        }
        myOpponent.checkDuck();
    }
    
    public void checkDuck()
    {
        if (Greenfoot.isKeyDown(myBoard.duck())){
            myAnimator.setDuck(true);
        }else{
            myAnimator.setDuck(false);
        }
    }
    
    public boolean atWorldEdge()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20){
            return true;
        }else{
            return false;
        }
    }
    
    public void setDirection()
    {
        int x1 = this.getX();
        int x2 = myOpponent.getX();
        if(x1 <= x2){
            myAnimator.setSprites(rightSheet);  
            leftFacing = false;
        }else{
            myAnimator.setSprites(leftSheet);
            leftFacing = true;
        }
    }
    
    public void setHit(boolean hit)
    {
        if(hit){
            getClocked = true;
        }else{
            getClocked = false;
        }
    }
    
    public boolean getDirection()
    {
        if(leftFacing){
            return true;
        }else{
            return false;
        }
    }

}
